% Filters (selection methods) are as follows:
% If selection_method is 1, coexistence of a reaction and its reverse reaction is not allowed (Filter 1).
% If selection_method is 2, coexistence of any A and any B is not allowed (Filter 2).
% A: reactions for glycolysis: 
%      hexokinase (glucokinase)
%      phosphofructokinase
%      pyruvate kinase
% B: reactions for gluconeogenesis: 
%      glucose-6-phosphatase
%      fructose-1,6-bisphosphatase
%      phosphoenolpyruvate carboxykinase
% If selection_method is 3, both the coexistences excluded in selection_methods 1 and 2 are not allowed (Filter 3).
% Please note the following.
% 1+1*i means the aldehyde carbon, C1, of glucose
% 1+2*i means C2 of glucose
% 1+3*i means C3 of glucose
% 1+4*i means C4 of glucose
% 1+5*i means C5 of glucose
% 1+6*i means C6 of glucose
% 15+i  means C of CO2

name = 'Glucose_C1_to_CO2_Filter3.txt';
name1 = ['cycle_use_',name];
name2 = ['dup_',name];
name3 = ['check_',name];
ex = exist(name,'file');
ex1 = exist(name1,'file');
ex2 = exist(name2,'file');
ex3 = exist(name3,'file');
if ( ex ~= 0 )|( ex1 ~= 0 )|( ex2 ~= 0 )|( ex3 ~= 0 )
  disp(['Please remove the files the beginning of which is Glucose_, cycle_use_Glucose_, dup_Glucose_, or check_Glucose_.']);
  return;
end
name = 'Glucose_C2_to_CO2_Filter3.txt';
name1 = ['cycle_use_',name];
name2 = ['dup_',name];
name3 = ['check_',name];
ex = exist(name,'file');
ex1 = exist(name1,'file');
ex2 = exist(name2,'file');
ex3 = exist(name3,'file');
if ( ex ~= 0 )|( ex1 ~= 0 )|( ex2 ~= 0 )|( ex3 ~= 0 )
  disp(['Please remove the files the beginning of which is Glucose_, cycle_use_Glucose_, dup_Glucose_, or check_Glucose_.']);
  return;
end
name = 'Glucose_C3_to_CO2_Filter3.txt';
name1 = ['cycle_use_',name];
name2 = ['dup_',name];
name3 = ['check_',name];
ex = exist(name,'file');
ex1 = exist(name1,'file');
ex2 = exist(name2,'file');
ex3 = exist(name3,'file');
if ( ex ~= 0 )|( ex1 ~= 0 )|( ex2 ~= 0 )|( ex3 ~= 0 )
  disp(['Please remove the files the beginning of which is Glucose_, cycle_use_Glucose_, dup_Glucose_, or check_Glucose_.']);
  return;
end
name = 'Glucose_C4_to_CO2_Filter3.txt';
name1 = ['cycle_use_',name];
name2 = ['dup_',name];
name3 = ['check_',name];
ex = exist(name,'file');
ex1 = exist(name1,'file');
ex2 = exist(name2,'file');
ex3 = exist(name3,'file');
if ( ex ~= 0 )|( ex1 ~= 0 )|( ex2 ~= 0 )|( ex3 ~= 0 )
  disp(['Please remove the files the beginning of which is Glucose_, cycle_use_Glucose_, dup_Glucose_, or check_Glucose_.']);
  return;
end
name = 'Glucose_C5_to_CO2_Filter3.txt';
name1 = ['cycle_use_',name];
name2 = ['dup_',name];
name3 = ['check_',name];
ex = exist(name,'file');
ex1 = exist(name1,'file');
ex2 = exist(name2,'file');
ex3 = exist(name3,'file');
if ( ex ~= 0 )|( ex1 ~= 0 )|( ex2 ~= 0 )|( ex3 ~= 0 )
  disp(['Please remove the files the beginning of which is Glucose_, cycle_use_Glucose_, dup_Glucose_, or check_Glucose_.']);
  return;
end
name = 'Glucose_C6_to_CO2_Filter3.txt';
name1 = ['cycle_use_',name];
name2 = ['dup_',name];
name3 = ['check_',name];
ex = exist(name,'file');
ex1 = exist(name1,'file');
ex2 = exist(name2,'file');
ex3 = exist(name3,'file');
if ( ex ~= 0 )|( ex1 ~= 0 )|( ex2 ~= 0 )|( ex3 ~= 0 )
  disp(['Please remove the files the beginning of which is Glucose_, cycle_use_Glucose_, dup_Glucose_, or check_Glucose_.']);
  return;
end

if ( exist('OCTAVE_VERSION') ~= 0 )
     load btk_connectivity_matrix;
else
     load btk_connectivity_matrix.mat;
end

disp(' ');

selection_method = 1;
disp('Filter 1: coexistence of a reaction and its reverse reaction is not allowed.');

s = 1+1*i;
d = 15+i;
x1 = btk_route(CM,s,d);
x = x1;
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C1, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);

s = 1+2*i;
d = 15+i;
x2 = btk_route(CM,s,d);
x = x2;
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C2, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);

s = 1+3*i;
d = 15+i;
x3 = btk_route(CM,s,d);
x = x3;
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C3, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);

s = 1+4*i;
d = 15+i;
x4 = btk_route(CM,s,d);
x = x4;
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C4, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);

s = 1+5*i;
d = 15+i;
x5 = btk_route(CM,s,d);
x = x5;
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C5, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);

s = 1+6*i;
d = 15+i;
x6 = btk_route(CM,s,d);
x = x6;
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C6, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);

disp(' ');

selection_method = 2;
disp('Filter 2: coexistence of any A and any B is not allowed.');
disp('A: reactions for glycolysis: ');
disp('     hexokinase (glucokinase)');
disp('     phosphofructokinase');
disp('     pyruvate kinase');
disp('B: reactions for gluconeogenesis: ');
disp('     glucose-6-phosphatase');
disp('     fructose-1,6-bisphosphatase');
disp('     phosphoenolpyruvate carboxykinase');

s = 1+1*i;
d = 15+i;
x = x1;
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C1, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);

s = 1+2*i;
d = 15+i;
x = x2;
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C2, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);

s = 1+3*i;
d = 15+i;
x = x3;
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C3, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);

s = 1+4*i;
d = 15+i;
x = x4;
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C4, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);

s = 1+5*i;
d = 15+i;
x = x5;
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C5, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);

s = 1+6*i;
d = 15+i;
x = x6;
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C6, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);

disp(' ');

selection_method = 3;
disp('Filter 3: both the coexistences excluded in Filters 1 and 2 are not allowed.');

s = 1+1*i;
d = 15+i;
x = x1;
name = 'Glucose_C1_to_CO2_Filter3.txt';
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C1, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);
fid = fopen(['check_',name],'a');
fprintf(fid,'%s\n', ['If any of thhe following A, B, C, D, and E occurs, it is recorded below. PPP: pentose phosphate pathway; G6PD: glucose-6-phosphate dehydrogenase']);
fprintf(fid,'%s\n', ['   A: A cycle using the same reaction repeatedly exists in PPP without repetition of G6PD.']);
fprintf(fid,'%s\n', ['   B: A cycle using the same reaction repeatedly exists in citric acid cycle without repetition of citrate synthase.']);
fprintf(fid,'%s\n', ['   C: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-glucose 6-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['   D: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-fructose 6-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['   E: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-glyceraldehyde 3-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['']);
fclose(fid);
i0 = 1;
p0 = [];
p1 = [];
p2 = [];
p3 = [];
n0 = 0;
n1 = 0;
n2 = 0;
n3 = 0;
while ( i0 <= path_noc )
  pn = path_no(1,i0);
  print_path(x,pn,name);
  tfv = print_cycle_rxn( x, pn, CM, ['cycle_use_',name] );
  [cm, rm] = print_dup(x,pn,['dup_',name]);
  print_CAC_PPP_check(pn,cm,rm,['check_',name]);
  if ( tfv == 0 )
    [r,c] = size(x{pn,1});
    p0 = [p0,c];
    n0 = n0 + 1;
  end
  if ( tfv == 1 )
    [r,c] = size(x{pn,1});
    p1 = [p1,c];
    n1 = n1 + 1;
  end
  if ( tfv == 2 )
    [r,c] = size(x{pn,1});
    p2 = [p2,c];
    n2 = n2 + 1;
  end
  if ( tfv == 3 )
    [r,c] = size(x{pn,1});
    p3 = [p3,c];
    n3 = n3 + 1;
  end
  i0 = i0 + 1;
end
disp(['         Frequency of use of citric acid cycle (CAC) ']);
disp(['         and pentose phosphate pathway (PPP) as a cycle, ']);
disp(['         which is judged from repeated use of citrate ']);
disp(['         synthase and glucose-6-phosphate dehydrogenase, ']);
disp(['         and distribution of path lengths']);
L = ['            None of CAC and PPP n=',int2str(n0), ' \t',int2str(min(p0)),'-',int2str(max(p0)),'\n'];
fprintf(L);
L = ['            CAC only            n=',int2str(n2), ' \t',int2str(min(p2)),'-',int2str(max(p2)),'\n'];
fprintf(L);
L = ['            PPP only            n=',int2str(n1), ' \t',int2str(min(p1)),'-',int2str(max(p1)),'\n'];
fprintf(L);
L = ['            Both of CAC and PPP n=',int2str(n3), ' \t',int2str(min(p3)),'-',int2str(max(p3)),'\n'];
fprintf(L);

s = 1+2*i;
d = 15+i;
x = x2;
name = 'Glucose_C2_to_CO2_Filter3.txt';
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C2, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);
fid = fopen(['check_',name],'a');
fprintf(fid,'%s\n', ['If any of thhe following A, B, C, D, and E occurs, it is recorded below. PPP: pentose phosphate pathway; G6PD: glucose-6-phosphate dehydrogenase']);
fprintf(fid,'%s\n', ['   A: A cycle using the same reaction repeatedly exists in PPP without repetition of G6PD.']);
fprintf(fid,'%s\n', ['   B: A cycle using the same reaction repeatedly exists in citric acid cycle without repetition of citrate synthase.']);
fprintf(fid,'%s\n', ['   C: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-glucose 6-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['   D: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-fructose 6-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['   E: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-glyceraldehyde 3-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['']);
fclose(fid);
i0 = 1;
p0 = [];
p1 = [];
p2 = [];
p3 = [];
n0 = 0;
n1 = 0;
n2 = 0;
n3 = 0;
while ( i0 <= path_noc )
  pn = path_no(1,i0);
  print_path(x,pn,name);
  tfv = print_cycle_rxn( x, pn, CM, ['cycle_use_',name] );
  [cm, rm] = print_dup(x,pn,['dup_',name]);
  print_CAC_PPP_check(pn,cm,rm,['check_',name]);
  if ( tfv == 0 )
    [r,c] = size(x{pn,1});
    p0 = [p0,c];
    n0 = n0 + 1;
  end
  if ( tfv == 1 )
    [r,c] = size(x{pn,1});
    p1 = [p1,c];
    n1 = n1 + 1;
  end
  if ( tfv == 2 )
    [r,c] = size(x{pn,1});
    p2 = [p2,c];
    n2 = n2 + 1;
  end
  if ( tfv == 3 )
    [r,c] = size(x{pn,1});
    p3 = [p3,c];
    n3 = n3 + 1;
  end
  i0 = i0 + 1;
end
disp(['         Frequency of use of citric acid cycle (CAC) ']);
disp(['         and pentose phosphate pathway (PPP) as a cycle, ']);
disp(['         which is judged from repeated use of citrate ']);
disp(['         synthase and glucose-6-phosphate dehydrogenase, ']);
disp(['         and distribution of path lengths']);
L = ['            None of CAC and PPP n=',int2str(n0), ' \t',int2str(min(p0)),'-',int2str(max(p0)),'\n'];
fprintf(L);
L = ['            CAC only            n=',int2str(n2), ' \t',int2str(min(p2)),'-',int2str(max(p2)),'\n'];
fprintf(L);
L = ['            PPP only            n=',int2str(n1), ' \t',int2str(min(p1)),'-',int2str(max(p1)),'\n'];
fprintf(L);
L = ['            Both of CAC and PPP n=',int2str(n3), ' \t',int2str(min(p3)),'-',int2str(max(p3)),'\n'];
fprintf(L);

s = 1+3*i;
d = 15+i;
x = x3;
name = 'Glucose_C3_to_CO2_Filter3.txt';
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C3, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);
fid = fopen(['check_',name],'a');
fprintf(fid,'%s\n', ['If any of thhe following A, B, C, D, and E occurs, it is recorded below. PPP: pentose phosphate pathway; G6PD: glucose-6-phosphate dehydrogenase']);
fprintf(fid,'%s\n', ['   A: A cycle using the same reaction repeatedly exists in PPP without repetition of G6PD.']);
fprintf(fid,'%s\n', ['   B: A cycle using the same reaction repeatedly exists in citric acid cycle without repetition of citrate synthase.']);
fprintf(fid,'%s\n', ['   C: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-glucose 6-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['   D: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-fructose 6-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['   E: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-glyceraldehyde 3-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['']);
fclose(fid);
i0 = 1;
p0 = [];
p1 = [];
p2 = [];
p3 = [];
n0 = 0;
n1 = 0;
n2 = 0;
n3 = 0;
while ( i0 <= path_noc )
  pn = path_no(1,i0);
  print_path(x,pn,name);
  tfv = print_cycle_rxn( x, pn, CM, ['cycle_use_',name] );
  [cm, rm] = print_dup(x,pn,['dup_',name]);
  print_CAC_PPP_check(pn,cm,rm,['check_',name]);
  if ( tfv == 0 )
    [r,c] = size(x{pn,1});
    p0 = [p0,c];
    n0 = n0 + 1;
  end
  if ( tfv == 1 )
    [r,c] = size(x{pn,1});
    p1 = [p1,c];
    n1 = n1 + 1;
  end
  if ( tfv == 2 )
    [r,c] = size(x{pn,1});
    p2 = [p2,c];
    n2 = n2 + 1;
  end
  if ( tfv == 3 )
    [r,c] = size(x{pn,1});
    p3 = [p3,c];
    n3 = n3 + 1;
  end
  i0 = i0 + 1;
end
disp(['         Frequency of use of citric acid cycle (CAC) ']);
disp(['         and pentose phosphate pathway (PPP) as a cycle, ']);
disp(['         which is judged from repeated use of citrate ']);
disp(['         synthase and glucose-6-phosphate dehydrogenase, ']);
disp(['         and distribution of path lengths']);
L = ['            None of CAC and PPP n=',int2str(n0), ' \t',int2str(min(p0)),'-',int2str(max(p0)),'\n'];
fprintf(L);
L = ['            CAC only            n=',int2str(n2), ' \t',int2str(min(p2)),'-',int2str(max(p2)),'\n'];
fprintf(L);
L = ['            PPP only            n=',int2str(n1), ' \t',int2str(min(p1)),'-',int2str(max(p1)),'\n'];
fprintf(L);
L = ['            Both of CAC and PPP n=',int2str(n3), ' \t',int2str(min(p3)),'-',int2str(max(p3)),'\n'];
fprintf(L);

s = 1+4*i;
d = 15+i;
x = x4;
name = 'Glucose_C4_to_CO2_Filter3.txt';
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C4, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);
fid = fopen(['check_',name],'a');
fprintf(fid,'%s\n', ['If any of thhe following A, B, C, D, and E occurs, it is recorded below. PPP: pentose phosphate pathway; G6PD: glucose-6-phosphate dehydrogenase']);
fprintf(fid,'%s\n', ['   A: A cycle using the same reaction repeatedly exists in PPP without repetition of G6PD.']);
fprintf(fid,'%s\n', ['   B: A cycle using the same reaction repeatedly exists in citric acid cycle without repetition of citrate synthase.']);
fprintf(fid,'%s\n', ['   C: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-glucose 6-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['   D: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-fructose 6-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['   E: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-glyceraldehyde 3-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['']);
fclose(fid);
i0 = 1;
p0 = [];
p1 = [];
p2 = [];
p3 = [];
n0 = 0;
n1 = 0;
n2 = 0;
n3 = 0;
while ( i0 <= path_noc )
  pn = path_no(1,i0);
  print_path(x,pn,name);
  tfv = print_cycle_rxn( x, pn, CM, ['cycle_use_',name] );
  [cm, rm] = print_dup(x,pn,['dup_',name]);
  print_CAC_PPP_check(pn,cm,rm,['check_',name]);
  if ( tfv == 0 )
    [r,c] = size(x{pn,1});
    p0 = [p0,c];
    n0 = n0 + 1;
  end
  if ( tfv == 1 )
    [r,c] = size(x{pn,1});
    p1 = [p1,c];
    n1 = n1 + 1;
  end
  if ( tfv == 2 )
    [r,c] = size(x{pn,1});
    p2 = [p2,c];
    n2 = n2 + 1;
  end
  if ( tfv == 3 )
    [r,c] = size(x{pn,1});
    p3 = [p3,c];
    n3 = n3 + 1;
  end
  i0 = i0 + 1;
end
disp(['         Frequency of use of citric acid cycle (CAC) ']);
disp(['         and pentose phosphate pathway (PPP) as a cycle, ']);
disp(['         which is judged from repeated use of citrate ']);
disp(['         synthase and glucose-6-phosphate dehydrogenase, ']);
disp(['         and distribution of path lengths']);
L = ['            None of CAC and PPP n=',int2str(n0), ' \t',int2str(min(p0)),'-',int2str(max(p0)),'\n'];
fprintf(L);
L = ['            CAC only            n=',int2str(n2), ' \t',int2str(min(p2)),'-',int2str(max(p2)),'\n'];
fprintf(L);
L = ['            PPP only            n=',int2str(n1), ' \t',int2str(min(p1)),'-',int2str(max(p1)),'\n'];
fprintf(L);
L = ['            Both of CAC and PPP n=',int2str(n3), ' \t',int2str(min(p3)),'-',int2str(max(p3)),'\n'];
fprintf(L);

s = 1+5*i;
d = 15+i;
x = x5;
name = 'Glucose_C5_to_CO2_Filter3.txt';
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C5, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);
fid = fopen(['check_',name],'a');
fprintf(fid,'%s\n', ['If any of thhe following A, B, C, D, and E occurs, it is recorded below. PPP: pentose phosphate pathway; G6PD: glucose-6-phosphate dehydrogenase']);
fprintf(fid,'%s\n', ['   A: A cycle using the same reaction repeatedly exists in PPP without repetition of G6PD.']);
fprintf(fid,'%s\n', ['   B: A cycle using the same reaction repeatedly exists in citric acid cycle without repetition of citrate synthase.']);
fprintf(fid,'%s\n', ['   C: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-glucose 6-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['   D: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-fructose 6-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['   E: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-glyceraldehyde 3-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['']);
fclose(fid);
i0 = 1;
p0 = [];
p1 = [];
p2 = [];
p3 = [];
n0 = 0;
n1 = 0;
n2 = 0;
n3 = 0;
while ( i0 <= path_noc )
  pn = path_no(1,i0);
  print_path(x,pn,name);
  tfv = print_cycle_rxn( x, pn, CM, ['cycle_use_',name] );
  [cm, rm] = print_dup(x,pn,['dup_',name]);
  print_CAC_PPP_check(pn,cm,rm,['check_',name]);
  if ( tfv == 0 )
    [r,c] = size(x{pn,1});
    p0 = [p0,c];
    n0 = n0 + 1;
  end
  if ( tfv == 1 )
    [r,c] = size(x{pn,1});
    p1 = [p1,c];
    n1 = n1 + 1;
  end
  if ( tfv == 2 )
    [r,c] = size(x{pn,1});
    p2 = [p2,c];
    n2 = n2 + 1;
  end
  if ( tfv == 3 )
    [r,c] = size(x{pn,1});
    p3 = [p3,c];
    n3 = n3 + 1;
  end
  i0 = i0 + 1;
end
disp(['         Frequency of use of citric acid cycle (CAC) ']);
disp(['         and pentose phosphate pathway (PPP) as a cycle, ']);
disp(['         which is judged from repeated use of citrate ']);
disp(['         synthase and glucose-6-phosphate dehydrogenase, ']);
disp(['         and distribution of path lengths']);
L = ['            None of CAC and PPP n=',int2str(n0), ' \t',int2str(min(p0)),'-',int2str(max(p0)),'\n'];
fprintf(L);
L = ['            CAC only            n=',int2str(n2), ' \t',int2str(min(p2)),'-',int2str(max(p2)),'\n'];
fprintf(L);
L = ['            PPP only            n=',int2str(n1), ' \t',int2str(min(p1)),'-',int2str(max(p1)),'\n'];
fprintf(L);
L = ['            Both of CAC and PPP n=',int2str(n3), ' \t',int2str(min(p3)),'-',int2str(max(p3)),'\n'];
fprintf(L);

s = 1+6*i;
d = 15+i;
x = x6;
name = 'Glucose_C6_to_CO2_Filter3.txt';
[path_no, path_no_dup_met, path_no_dup_rxn] = select_path(x,selection_method,CM);
[xr,xc] = size(x);
[path_nor, path_noc] = size(path_no);
disp('Glucose, C6, to CO2');
disp(['   Total paths:    ', int2str(xr)]);
disp(['   Selected paths: ', int2str(path_noc)]);
[path_no_dup_metr, path_no_dup_metc] = size(path_no_dup_met);
disp(['      Multiple appearance of the same metabolite: ', int2str(path_no_dup_metc), '.']);
[path_no_dup_rxnr, path_no_dup_rxnc] = size(path_no_dup_rxn);
disp(['      Multiple appearance of the same reaction:   ', int2str(path_no_dup_rxnc), '.']);
fid = fopen(['check_',name],'a');
fprintf(fid,'%s\n', ['If any of thhe following A, B, C, D, and E occurs, it is recorded below. PPP: pentose phosphate pathway; G6PD: glucose-6-phosphate dehydrogenase']);
fprintf(fid,'%s\n', ['   A: A cycle using the same reaction repeatedly exists in PPP without repetition of G6PD.']);
fprintf(fid,'%s\n', ['   B: A cycle using the same reaction repeatedly exists in citric acid cycle without repetition of citrate synthase.']);
fprintf(fid,'%s\n', ['   C: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-glucose 6-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['   D: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-fructose 6-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['   E: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-glyceraldehyde 3-phosphate or G6PD.']);
fprintf(fid,'%s\n', ['']);
fclose(fid);
i0 = 1;
p0 = [];
p1 = [];
p2 = [];
p3 = [];
n0 = 0;
n1 = 0;
n2 = 0;
n3 = 0;
while ( i0 <= path_noc )
  pn = path_no(1,i0);
  print_path(x,pn,name);
  tfv = print_cycle_rxn( x, pn, CM, ['cycle_use_',name] );
  [cm, rm] = print_dup(x,pn,['dup_',name]);
  print_CAC_PPP_check(pn,cm,rm,['check_',name]);
  if ( tfv == 0 )
    [r,c] = size(x{pn,1});
    p0 = [p0,c];
    n0 = n0 + 1;
  end
  if ( tfv == 1 )
    [r,c] = size(x{pn,1});
    p1 = [p1,c];
    n1 = n1 + 1;
  end
  if ( tfv == 2 )
    [r,c] = size(x{pn,1});
    p2 = [p2,c];
    n2 = n2 + 1;
  end
  if ( tfv == 3 )
    [r,c] = size(x{pn,1});
    p3 = [p3,c];
    n3 = n3 + 1;
  end
  i0 = i0 + 1;
end
disp(['         Frequency of use of citric acid cycle (CAC) ']);
disp(['         and pentose phosphate pathway (PPP) as a cycle, ']);
disp(['         which is judged from repeated use of citrate ']);
disp(['         synthase and glucose-6-phosphate dehydrogenase, ']);
disp(['         and distribution of path lengths']);
L = ['            None of CAC and PPP n=',int2str(n0), ' \t',int2str(min(p0)),'-',int2str(max(p0)),'\n'];
fprintf(L);
L = ['            CAC only            n=',int2str(n2), ' \t',int2str(min(p2)),'-',int2str(max(p2)),'\n'];
fprintf(L);
L = ['            PPP only            n=',int2str(n1), ' \t',int2str(min(p1)),'-',int2str(max(p1)),'\n'];
fprintf(L);
L = ['            Both of CAC and PPP n=',int2str(n3), ' \t',int2str(min(p3)),'-',int2str(max(p3)),'\n'];
fprintf(L);
disp(' ');
disp('Files the beginning of which is Glucose_, cycle_use_, dup_, or check_ are generated. They are results related to the paths selected using Filter 3.');
disp('   Files the beginning of which is Glucose_ describe each path as a sequence of metabolites and processes (reactions or transport processes).');
disp('   Files the beginning of which is cycle_use_Glucose_ describe use of citric acid cycle (CAC) and pentose phosphate pathway (PPP) as a cycle, which is judged from repeated use of citrate synthase and glucose-6-phosphate dehydrogenase (G6PD), and multiple use of D-fructose 6-phosphate or D-glyceraldehyde 3-phosphate without repetition of G6PD reaction.');
disp('   Files the beginning of which is dup_Glucose_ describe multiple use of the same metabolite or process (reaction or transtort) in the indicated path.');
disp('   Files the beginning of which is check_Glucose_ describe other information about the indicated path.');

