% print_CAC_PPP_check(pn, comp_multiple, rxn_multiple, name)
% print_CAC_PPP_check prints information of the path, pn, related to citric acid cycle (CAC) and pentose phosphate pathway (PPP).
% pn: path number
% comp_multiple: list of the compound numbers which appear multiple times in the path, pn
% rxn_multiple: list of the reaction numbers which appear multiple times in the path, pn
% name: name of result file
function print_CAC_PPP_check(pn, comp_multiple, rxn_multiple, name);
cm = comp_multiple;
rm = rxn_multiple;
fid = fopen(name,'a');
tfv1 = 0;
r1 = [24:30,-30:-24];
[r1r,r1c] = size(r1);
i0 = 1;
while ( i0 <= r1c )
  rn = r1(1,i0);
  tfv1 = tfv1 + ((isempty(find(rm==rn))~=1)&(isempty(find(rm==23))==1));
  i0 = i0 + 1;
end
if ( tfv1 >= 1 )
  fprintf(fid,'%s\n', ['Pathway No. ', int2str(pn), '  A: A cycle using the same reaction repeatedly exists in PPP without repetition of G6PD.']);
end
tfv1 = 0;
r1 = [15:22,-22:-15];
[r1r,r1c] = size(r1);
i0 = 1;
while ( i0 <= r1c )
  rn = r1(1,i0);
  tfv1 = tfv1 + ((isempty(find(rm==rn))~=1)&(isempty(find(rm==14))==1));
  i0 = i0 + 1;
end
if ( tfv1 >= 1 )
  fprintf(fid,'%s\n', ['Pathway No. ', int2str(pn), '  B: A cycle using the same reaction repeatedly exists in citric acid cycle without repetition of citrate synthase.']);
end
tfv1 = 0;
c1 = [5,3,26:32];
[c1r,c1c] = size(c1);
i0 = 1;
while ( i0 <= c1c )
  cn = c1(1,i0);
  tfv1 = tfv1 + (((isempty(find(cm==cn))~=1)&(isempty(find(cm==2))==1))&(isempty(find(rm==23))==1));
  i0 = i0 + 1;
end
if ( tfv1 >= 1 )
  fprintf(fid,'%s\n', ['Pathway No. ', int2str(pn), '  C: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-glucose 6-phosphate or G6PD.']);
end
tfv1 = 0;
c1 = [5,2,26:32];
[c1r,c1c] = size(c1);
i0 = 1;
while ( i0 <= c1c )
  cn = c1(1,i0);
  tfv1 = tfv1 + (((isempty(find(cm==cn))~=1)&(isempty(find(cm==3))==1))&(isempty(find(rm==23))==1));
  i0 = i0 + 1;
end
if ( tfv1 >= 1 )
  fprintf(fid,'%s\n', ['Pathway No. ', int2str(pn), '  D: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-fructose 6-phosphate or G6PD.']);
end
tfv1 = 0;
c1 = [2,3,26:32];
[c1r,c1c] = size(c1);
i0 = 1;
while ( i0 <= c1c )
  cn = c1(1,i0);
  tfv1 = tfv1 + (((isempty(find(cm==cn))~=1)&(isempty(find(cm==5))==1))&(isempty(find(rm==23))==1));
  i0 = i0 + 1;
end
if ( tfv1 >= 1 )
  fprintf(fid,'%s\n', ['Pathway No. ', int2str(pn), '  E: A cycle using the same metabolite repeatedly exists in PPP without repetition of D-glyceraldehyde 3-phosphate or G6PD.']);
end
fclose(fid);
