% [drM,drn] = reduce_matrix(M)
% In this function, M is reduced to a matrix, drM, where the same row appears only once. In drn, it is written how many times each row of drM appears in M.
% Example:
% Assume M = [1,1;2,2;2,2;3,3] 
% Conduct [drM,drn] = reduce_matrix(M);
% Then, the following are obtained.
%    drM = [1,1;2,2;3,3]
%    drn = [1;2;1]
function [drM,drn] = reduce_matrix(M);
[Mr,Mc] = size(M);
if ( Mr == 1 )
     drM = M;
     drn = 1;
elseif ( isempty(M) == 1 )
     drM = [];
     drn = [];
else
     w = zeros(Mr,1);
     i0 = 1;
     while ( i0 <= Mr )
          if ( w(i0,1) == 0 )
               w(i0,1) = 1;
               j0 = i0 + 1;
               while ( j0 <= Mr )
                    if ( ( w(j0,1) == 0 ) & ( M(i0,:) == M(j0,:)) )
                         w(j0,1) = -1;
                         w(i0,1) = w(i0,1) + 1;
                    end
                  j0 = j0 + 1;
               end
          end
        i0 = i0 + 1;
     end
     v = find( w(:,1) >= 1 );
     drM = M(v,:);
     drn = w(v,1);
end
